.686
.model flat,stdcall
	
	option casemap:none
	include \masm32\include\windows.inc
	
	include \masm32\include\kernel32.inc
	include \masm32\include\user32.inc
	include \masm32\include\winmm.inc
	
	includelib \masm32\lib\kernel32.lib
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\winmm.lib
	
.data
	
	jic db "Could not set timer resolution",0
	
	wcname db "SetTimerResolution",0
	wc WNDCLASSEX <sizeof WNDCLASSEX,0,offset wndproc,0,0,0,0,0,0,0,offset wcname,0>
	
	wtitle db "SetTimerResolution",0
	wmsg MSG <>
	
.code
	
wndproc proc hwnd:dword,msg:dword,wpar:dword,lpar:dword
	
	.if [msg] == WM_CREATE
		
		xor eax,eax
		
	.elseif [msg] == WM_DESTROY
		
		invoke PostQuitMessage,0
		xor eax,eax
		
	.else
		
		invoke DefWindowProc,[hwnd],[msg],[wpar],[lpar]
		
	.endif
	
	ret
	
wndproc endp
	
start:
	
	invoke timeBeginPeriod,1
	
	.if eax == TIMERR_NOERROR
		
		invoke GetModuleHandle,0
		mov [wc.hInstance],eax
		
		invoke RegisterClassEx,addr wc
		
		invoke CreateWindowEx,0,addr wcname,addr wtitle,0,0,0,10,10,0,0,[wc.hInstance],0
		
		.while 1
			
			invoke GetMessage,addr wmsg,0,0,0
			.break .if eax == 0
			
			invoke DispatchMessage,addr wmsg
			
		.endw
		
		invoke timeEndPeriod,1
		
	.else
		
		invoke MessageBox,0,addr jic,0,MB_ICONEXCLAMATION
		
	.endif
	
	invoke ExitProcess,0
	ret
	
end start